"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.WebpackRecursiveLoader = WebpackRecursiveLoader;

var _loaderUtils = require("loader-utils");

var t = _interopRequireWildcard(require("@babel/types"));

var _generator = _interopRequireDefault(require("@babel/generator"));

var _util = require("./util");

var _path = _interopRequireDefault(require("path"));

var _util2 = require("util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function WebpackRecursiveLoader(source) {
  var _getOptions = (0, _loaderUtils.getOptions)(this),
      _getOptions$fileSyste = _getOptions.fileSystem,
      fileSystem = _getOptions$fileSyste === void 0 ? this.fs : _getOptions$fileSyste,
      plugin = _getOptions.plugin,
      root = _getOptions.root,
      dirPath = _getOptions.path;

  var readDirAsync = (0, _util2.promisify)(fileSystem.readdir.bind(fileSystem));
  var statAsync = (0, _util2.promisify)(fileSystem.stat.bind(fileSystem));
  var callback = this.async();

  _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
    var _context;

    var absDirPath, entries, dependencies, keys, body, _iterator, _step, entry, type, basename, path, absPath, file, name, filePath, _toQueryString, query, hot, ast;

    return regeneratorRuntime.wrap(function _callee2$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            absDirPath = _path["default"].join(root, dirPath);
            _context3.next = 3;
            return readDirAsync(absDirPath);

          case 3:
            entries = _context3.sent;
            _context3.next = 6;
            return Promise.all((_context = entries, _util.map).call(_context, /*#__PURE__*/function () {
              var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(entry) {
                var stats;
                return regeneratorRuntime.wrap(function _callee$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        _context2.next = 2;
                        return statAsync(_path["default"].join(absDirPath, entry));

                      case 2:
                        stats = _context2.sent;
                        stats.name = entry;
                        return _context2.abrupt("return", stats);

                      case 5:
                      case "end":
                        return _context2.stop();
                    }
                  }
                }, _callee);
              }));

              return function (_x) {
                return _ref2.apply(this, arguments);
              };
            }()));

          case 6:
            entries = _context3.sent;
            dependencies = [];
            keys = new Map();
            body = [];
            _iterator = _createForOfIteratorHelper(entries);
            _context3.prev = 11;

            _iterator.s();

          case 13:
            if ((_step = _iterator.n()).done) {
              _context3.next = 41;
              break;
            }

            entry = _step.value;
            type = void 0;

            if (!entry.isFile()) {
              _context3.next = 20;
              break;
            }

            type = 'file';
            _context3.next = 25;
            break;

          case 20:
            if (!entry.isDirectory()) {
              _context3.next = 24;
              break;
            }

            type = 'directory';
            _context3.next = 25;
            break;

          case 24:
            return _context3.abrupt("continue", 39);

          case 25:
            basename = entry.name;
            path = _path["default"].join(dirPath, basename);
            absPath = _path["default"].join(root, path);
            file = {
              basename: basename,
              path: path,
              absPath: absPath,
              type: type
            };
            name = plugin._getNameForFile(file);

            if (!(name == null)) {
              _context3.next = 32;
              break;
            }

            return _context3.abrupt("continue", 39);

          case 32:
            filePath = absPath;

            if (type === 'directory') {
              query = (0, _util.toQueryString)((_toQueryString = {}, _defineProperty(_toQueryString, plugin.keyword, plugin.namespace), _defineProperty(_toQueryString, "root", root), _toQueryString));
              filePath = "".concat(filePath, "?").concat(query);
            }

            dependencies.push(filePath);

            if (!keys.has(name)) {
              _context3.next = 37;
              break;
            }

            throw new Error("Naming conflict for name '".concat(name, "':\n").concat(path, "\n").concat(keys.get(name)));

          case 37:
            keys.set(name, path); //add import statement

            body.push(t.importDeclaration([t.importNamespaceSpecifier(t.identifier(name))], t.stringLiteral(filePath)));

          case 39:
            _context3.next = 13;
            break;

          case 41:
            _context3.next = 46;
            break;

          case 43:
            _context3.prev = 43;
            _context3.t0 = _context3["catch"](11);

            _iterator.e(_context3.t0);

          case 46:
            _context3.prev = 46;

            _iterator.f();

            return _context3.finish(46);

          case 49:
            //export all the keys
            if (keys.length > 0) {
              body.push(t.exportNamedDeclaration(null, _toConsumableArray(_util.map.call(keys, function (key) {
                key = t.identifier(key);
                return t.exportSpecifier(key, key);
              }))));
            } //add hot reload support


            hot = t.memberExpression(t.identifier('module'), t.identifier('hot'));
            body.push(t.ifStatement(hot, t.blockStatement([t.expressionStatement(t.callExpression(t.memberExpression(hot, t.identifier('accept')), [t.arrayExpression(_toConsumableArray(_util.map.call(dependencies, function (dep) {
              return t.stringLiteral(dep);
            })))]))])));
            ast = t.program(body, [], 'module');
            source = (0, _generator["default"])(ast).code;
            callback(null, source);

          case 55:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee2, null, [[11, 43, 46, 49]]);
  }))()["catch"](function (err) {
    return callback(err);
  });
}
//# sourceMappingURL=loader.js.map